unit Auswertungsunit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TAuswertung = class(TForm)
    Ueberschrift: TLabel;
    Button1: TButton;
    Name: TLabel;
    Punkte: TLabel;
    Gesamtpunktzahl: TLabel;
    b_highscoreliste: TListBox;
    Hintergrund: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Auswertung: TAuswertung;

implementation

uses Schwerkraft, Spielernameneingabe, Titel, RaumSchiffThreads;

{$R *.DFM}

procedure TAuswertung.Button1Click(Sender: TObject);
var i:integer;
begin
  selbstzerstoerung:=true;
  aktiveSpielerzahl:=0;
  for i:=1 to maxspielerzahl do with spieler[i] do
  begin
    aktiv:=(name>'');
    if aktiv then inc(aktiveSpielerZahl);
  end;
  f_universum.NeuesSpiel(sender);
end;

procedure TAuswertung.FormShow(Sender: TObject);
var i,j,tausch:integer;
var z,s:string;
var reihenfolge:array[1..maxspielerzahl] of integer;
begin
  f_universum.tim_auswertung.enabled:=false;
  f_universum.slprint(1,spieler[aktuellerspieler].name+' hat berlebt! (42 Bonuspunkte)');
  inc(spieler[aktuellerspieler].aktpunkte,42);

  for i:=1 to maxspielerzahl do
  begin
    reihenfolge[i]:=i;
    with spieler[i] do inc(gesamtpunkte,aktpunkte);
  end;

  {Sortieren}
  for i:=1 to maxspielerzahl-1 do
    for j:=maxspielerzahl downto i+1 do
      if spieler[reihenfolge[i]].gesamtpunkte
        <spieler[reihenfolge[j]].gesamtpunkte
      then
        begin
          tausch:=reihenfolge[i];
          reihenfolge[i]:=reihenfolge[j];
          reihenfolge[j]:=tausch;
        end;

  for i:=1 to maxspielerzahl do with spieler[reihenfolge[i]] do
    if name>'' then
      begin
        z:=name;
        while length(z)<14 do z:=z+' ';
        str(aktpunkte:4,s);
        z:=z+s;
        str(gesamtpunkte:9,s);
        z:=z+s;
        b_highscoreliste.items[i-1]:=z;
      end
      else
        b_highscoreliste.items[i-1]:='-';
end;

end.
